package com.a2zss.ISO8583.log;


/**
 * Copyright AZS Services 2002-2011 http://www.a2zss.com 
 * @author andri
 * The log adapter class is supplemental adapter to use
 * provided as free add on to ISO-8583 SDK
 * SDK debugging into commons log framework
 * usage: 
 * 	   isosdk.setOutput(new java.io.PrintStream(new LogAdapter(log)));
 *     isosdk.setDebuglevel(5);
 *
 */
public class LogAdapter extends java.io.OutputStream {

    org.apache.commons.logging.Log log=null;
    StringBuffer sb=null;
    
    public LogAdapter(org.apache.commons.logging.Log log)
    {
        this.log=log;
        sb=new StringBuffer(64);
    }


    public void write(int b) throws java.io.IOException
    {

        if ( ((char)b=='\r' || (char)b=='\n' && sb.length()>0) || sb.length()>1000)
        {
            if (log.isTraceEnabled()) log.trace(sb.toString());
            sb=null;
            sb=new StringBuffer(64);

        }    
        else if ( (char)b!='\r' && (char)b!='\n' )
            sb.append((char)b);
    

    }    
        
    protected void finalize() throws Throwable
    {
        if (sb!=null && sb.length()>0 && log.isTraceEnabled() ) 
            log.trace(sb.toString());
        sb=null;
        log=null;

    }   
    
}    